Imports Telerik.WinControls.UI

Public Class Form1
    Private newRow As GridViewDataRowInfo
    Private dt As DataTable = New DataTable()
    Private isAddedProgrammatically As Boolean = False

    Public Sub New()
        InitializeComponent()

        Dim col1 As DataColumn = New DataColumn()
        col1.Caption = "id"
        col1.DataType = GetType(Integer)
        col1.AutoIncrement = True
        col1.Unique = True
        col1.ReadOnly = True
        dt.Columns.Add(col1)

        Dim col2 As DataColumn = New DataColumn()
        col2.Caption = "data"
        col2.DataType = GetType(String)
        dt.Columns.Add(col2)

        Dim col3 As DataColumn = New DataColumn()
        col3.Caption = "time"
        col3.DataType = GetType(Integer)
        dt.Columns.Add(col3)

        For counter As Integer = 0 To 99
            Dim dr As DataRow = dt.NewRow()
            dr(1) = "text" & counter.ToString()
            dr(2) = counter
            dt.Rows.Add(dr)
        Next counter

        Me.RadGridView1.DataSource = dt

        AddHandler RadGridView1.CurrentRowChanged, AddressOf radGridView1_CurrentRowChanged
        AddHandler RadGridView1.RowsChanged, AddressOf radGridView1_RowsChanged
    End Sub

    Private Sub radGridView1_CurrentRowChanged(ByVal sender As Object, ByVal e As CurrentRowChangedEventArgs)
        If TypeOf e.OldRow Is GridViewNewRowInfo Then
            If Not newRow Is Nothing AndAlso Me.RadGridView1.Rows.IndexOf(newRow) <> -1 Then
                'Row added to RadGridView 
                Console.WriteLine("Row added to RadGridView")
                Me.RadGridView1.CurrentRow = newRow
                Me.RadGridView1.GridElement.ScrollToRow(newRow)
            End If
            newRow = Nothing
        End If
    End Sub

    Private Sub radGridView1_RowsChanged(ByVal sender As Object, ByVal e As Telerik.WinControls.UI.GridViewCollectionChangedEventArgs)
        If e.Action = Telerik.WinControls.Data.NotifyCollectionChangedAction.Add Then
            Console.WriteLine("Row added")

            newRow = TryCast(e.NewItems(0), GridViewDataRowInfo)

            If isAddedProgrammatically Then
                ' If the row is programmatically added you do not need CurrentRowChanged
                isAddedProgrammatically = False
                Console.WriteLine("row added programmatically")
            End If
        End If
    End Sub

    Private Sub radButton1_Click(ByVal sender As Object, ByVal e As EventArgs) Handles RadButton1.Click
        isAddedProgrammatically = True

        Dim dr As DataRow = dt.NewRow()
        dr(1) = "new text"
        dr(2) = 1000
        dt.Rows.Add(dr)
    End Sub
End Class